//----------------------------------------------------------------------//
// NyanFi																//
//  摜r[Xbh												//
//----------------------------------------------------------------------//
#ifndef ImgViewThreadH
#define ImgViewThreadH
//---------------------------------------------------------------------------
#include <System.Classes.hpp>

//---------------------------------------------------------------------------
class TImgViewThread : public TThread
{
private:
	UnicodeString Img_f_name;
	__int64		  Img_f_size;
	TDateTime	  Img_f_time;
	UnicodeString Img_rot_str;	//^t@C̉]E]

	UnicodeString MsgStr;
	bool MsgIsErr;

	void __fastcall ClearImage();
	void __fastcall DrawImage();
	void __fastcall DrawViewBuff();
	void __fastcall DrawMessage();
	void __fastcall Execute();

	//XbhZ[tlvpeB
	TMultiReadExclusiveWriteSynchronizer *TaskRWLock;
	bool FTaskBusy;
	bool __fastcall GetTaskBusy();
	void __fastcall SetTaskBusy(bool Value);

public:
	UnicodeString FileName;	//摜t@C
	UnicodeString FileName2;

	__property bool TaskBusy = {read = GetTaskBusy,  write = SetTaskBusy};	//

	bool ReqRedraw;			//ĕ`v
	bool ReqReload;			//[hv
	bool ReqChange;			//rbg}bvύXv
	bool ReqClear;			//ʃNAv
	bool ReqVideo;			//(TlC\v)
	int  Rotation;			//]/]v (1,3,4,5)
	int  ExifOri;			//Exif ̕
	int  ZoomRatio;			//Y[{(%)
	double ZoomRatioF;

	bool Fitted;			//tBbg\
	bool GrayScaled;		//O[XP[\
	bool ShowGrid;			//Obh\
	bool UseViewBuff;		//CŐݒ肳ꂽobt@egp

	bool ImgIsWmf;
	bool ChgPrvCur;			//vr[̃}EX|C^ύX

	Graphics::TBitmap *ImgBuff;		//摜obt@(TCY)
	Graphics::TBitmap *ViewBuff;	//\obt@
	Graphics::TBitmap *ChgBuff;
	TMetafile *MetaBuff;			//^t@Cpobt@

	__fastcall TImgViewThread(bool CreateSuspended);
};
//---------------------------------------------------------------------------
#endif
